'''
Script to set the URL for a HTTP request and trigger the POST Request
Ex:
/usr/bin/python3 /var/www/nebuleair_pro_4g/SARA/SSL/full_test_HTTP.py ttyAMA2 data.nebuleair.fr
To do: need to add profile id as parameter

First profile id:
    AT+UHTTP=0,1,"data.nebuleair.fr"
Second profile id:
    AT+UHTTP=1,1,"api-prod.uspot.probesys.net"
Third profile id:
    AT+UHTTP=2,1,"aircarto.fr"

'''

import serial
import time
import sys
import json

parameter = sys.argv[1:]  # Exclude the script name
#print("Parameters received:")
port='/dev/'+parameter[0] # ex: ttyAMA2
url = parameter[1]  # ex: data.mobileair.fr

profile_id = 3

#get baudrate
def load_config(config_file):
    try:
        with open(config_file, 'r') as file:
            config_data = json.load(file)
        return config_data
    except Exception as e:
        print(f"Error loading config file: {e}")
        return {}

# Define the config file path
config_file = '/var/www/nebuleair_pro_4g/config.json'
# Load the configuration data
config = load_config(config_file)
# Access the shared variables
baudrate = config.get('SaraR4_baudrate', 115200)
send_uSpot = config.get('send_uSpot', False) 

def read_complete_response(serial_connection, timeout=2, end_of_response_timeout=2):
    response = bytearray()
    serial_connection.timeout = timeout
    end_time = time.time() + end_of_response_timeout

    while True:
        if serial_connection.in_waiting > 0:
            data = serial_connection.read(serial_connection.in_waiting)
            response.extend(data)
            end_time = time.time() + end_of_response_timeout  # Reset timeout on new data
        elif time.time() > end_time:
            break
        time.sleep(0.1)  # Short sleep to prevent busy waiting

    return response.decode('utf-8', errors='replace')

ser_sara = serial.Serial(
    port=port,  #USB0 or ttyS0
    baudrate=baudrate, #115200 ou 9600
    parity=serial.PARITY_NONE, #PARITY_NONE, PARITY_EVEN or PARITY_ODD
    stopbits=serial.STOPBITS_ONE,
    bytesize=serial.EIGHTBITS,
    timeout = 2
)



try:
   

    #step 4: set url (op_code = 1)
    print("****")
    print("SET URL")
    command = f'AT+UHTTP={profile_id},1,"{url}"\r'
    ser_sara.write((command + '\r').encode('utf-8'))
    response_SARA_5 = read_complete_response(ser_sara)
    print(response_SARA_5)
    time.sleep(1)

    #step 4: set PORT (op_code = 5)
    print("****")
    print("SET PORT")
    command = f'AT+UHTTP={profile_id},5,80\r'
    ser_sara.write((command + '\r').encode('utf-8'))
    response_SARA_55 = read_complete_response(ser_sara)
    print(response_SARA_55)
    time.sleep(1)


    #step 4: trigger the request
    print("****")
    print("Trigger POST REQUEST")
    command = f'AT+UHTTPC={profile_id},1,"/pro_4G/test.php","http.resp"\r'
    ser_sara.write((command + '\r').encode('utf-8'))
    response_SARA_6 = read_complete_response(ser_sara)
    print(response_SARA_6)
    time.sleep(1)

    #READ REPLY
    print("****")
    print("Read reply from server")
    ser_sara.write(b'AT+URDFILE="http.resp"\r')              
    response_SARA_7 = read_complete_response(ser_sara)        
    print("Reply from server:")
    print(response_SARA_7)


except serial.SerialException as e:
    print(f"Error: {e}")

finally:
    if ser_sara.is_open:
        ser_sara.close()
        print("****")
        #print("Serial closed")

